require "import"
import "android.widget.*"
import "android.view.*"
import "com.androlua.*"
import "cjson"
import "java.io.File"

dataPath = "/storage/emulated/0/解说/Plugins/سِلاحُ المُؤمِن/data.json"

adhkar = {
  "سُبْحَانَ اللَّه",
  "الْـحَمْدُ لِلَّه",
  "لَا إِلٰهَ إِلَّا الْلَّه",
  "الْلَّهُ أَكْبَر",
  "أَسْتَغْفِرُ الْلَّهَ الْعَظِيمْ، هُوَ التَّوَّابُ الرَّحِيمْ",
  "اللَّهُمَّ صَلِّ وَسَلِّمْ وَبَارِكْ عَلَى سَيِّدِنَا مُحَمَّدٍ النَّبِيِّ الْأُمِّيِّ وَعَلَى آلِهِ وَصَحْبِهِ أَجْمَعِيْن",
  "اللَّهُمَّ صَلِّ وَسَلِّمْ وَبَارِكْ عَلَى سَيِّدِنَا مُحَمَّدٍ وَعَلَى آلِهِ عَدَدَ كَمَالِ اللَّهِ وَكَمَا يَلِيقُ بِكَمَالِه",
  "لَا إِلٰهَ إِلَّا اللَّهُ وَحْدَهُ لَا شَرِيكَ لَهُ، لَهُ الْمُلْكُ وَلَهُ الْـحَمْدْ، يُحْيِي وَيُمِيتُ، وَهُوَ عَلَى كُلِّ شَيْءٍ قَدِيرْ",
  "يَا الْلَّه",
  "يَا لَطِيفْ",
  "يَا دَائِمْ",
  "يَا عَزِيزْ"
}

counts = {}
currentIndex = 1
sayMode = 1 -- 1: ذكر والعدد, 2: العدد فقط, 3: بدون نطق

function loadData()
  local file = io.open(dataPath, "r")
  if file then
    local content = file:read("*a")
    file:close()
    local saved = cjson.decode(content)
    if saved then
      adhkar = saved.adhkar or adhkar
      counts = saved.counts or {}
      currentIndex = saved.currentIndex or 1
      for i = #counts + 1, #adhkar do
        counts[i] = 0
      end
    end
  end
end

function saveData()
  local file = io.open(dataPath, "w")
  if file then
    local content = cjson.encode({adhkar=adhkar, counts=counts, currentIndex=currentIndex})
    file:write(content)
    file:close()
  end
end

for i = 1, #adhkar do
  counts[i] = counts[i] or 0
end

loadData()
currentDhikr = adhkar[currentIndex]

dlg = LuaDialog(this)
dlg.title = "مَنْ لَا وِرْدَ لَهُ لَا وَارِدَ لَهُ"

dlg.setView(loadlayout({
  LinearLayout,
  orientation=1,
  layout_width="fill",
  layout_height="wrap",
  background="#000000",
  {
    TextView,
    id="tvCurrentDhikr",
    text=currentDhikr,
    textSize="24sp",
    textColor="#FFFFFF",
    gravity="center",
    layout_width="match",
    layout_height="wrap"
  },
  {
    Button,
    id="btnAddDhikr",
    text="إضافة ذكر جديد",
    textSize="22sp",
    background="#ff6600",
    layout_width="match",
    layout_height="wrap"
  },
  {
    Button,
    id="btnDeleteDhikr",
    text="حذف الذكر الحالي",
    textSize="22sp",
    background="#cc0000",
    layout_width="match",
    layout_height="wrap"
  },
  {
    LinearLayout,
    orientation=0,
    layout_width="match",
    layout_height="wrap",
    {
      Button,
      id="btnPrev",
      text="الذكر السابق",
      textSize="25sp",
      background="#ff6600",
      layout_width="0dp",
      layout_weight=1,
      layout_height="wrap"
    },
    {
      Button,
      id="btnNext",
      text="الذكر التالي",
      textSize="25sp",
      background="#ff9900",
      layout_width="0dp",
      layout_weight=1,
      layout_height="wrap"
    }
  },
  {
    LinearLayout,
    orientation=0,
    layout_width="match",
    layout_height="wrap",
    {
      Button,
      id="btnMinus",
      text="تَرَاجَعْ",
      textSize="25sp",
      background="#a4ff6d00",
      layout_width="0dp",
      layout_weight=1,
      layout_height="wrap"
    },
    {
      Button,
      id="btnCount",
      text="0",
      textSize="30sp",
      background="#ff000000",
      layout_width="0dp",
      layout_weight=1,
      layout_height="wrap"
    },
    {
      Button,
      id="btnPlus",
      text="تَقَدَّمْ",
      textSize="25sp",
      background="#a300ff00",
      layout_width="0dp",
      layout_weight=1,
      layout_height="wrap"
    }
  },
  {
    Button,
    id="btnToggleSayMode",
    text="نطق العدد فقط",
    textSize="22sp",
    background="#3300cc",
    layout_width="match",
    layout_height="wrap"
  },
  {
    Button,
    id="btnReset",
    text="البدء من جديد",
    textSize="25sp",
    background="#ffff4c00",
    layout_width="match",
    layout_height="wrap"
  },
  {
    Button,
    id="btnClearAll",
    text="مسح جميع العدادات",
    textSize="22sp",
    background="#cc6600",
    layout_width="match",
    layout_height="wrap"
  }
}))

function updateUI()
  btnCount.text = tostring(math.floor(counts[currentIndex]))
  tvCurrentDhikr.text = adhkar[currentIndex]
end

btnAddDhikr.onClick = function()
  local inputDialog = LuaDialog(this)
  inputDialog.title = "أدخل اسم الذكر الجديد"
  inputDialog.setView(loadlayout({
    LinearLayout,
    orientation=1,
    layout_width="fill",
    layout_height="wrap",
    {
      EditText,
      id="etNewDhikr",
      hint="اكتب هنا اسم الذكر",
      layout_width="fill",
      layout_height="wrap"
    },
    {
      Button,
      text="أضف الذكر",
      textSize="18sp",
      layout_width="wrap",
      layout_height="wrap",
      onClick=function()
        local newDhikr = etNewDhikr.text
        if newDhikr ~= "" then
          table.insert(adhkar, 1, newDhikr)
          counts = {}
          for i = 1, #adhkar do counts[i] = 0 end
          currentIndex = 1
          currentDhikr = adhkar[currentIndex]
          updateUI()
          saveData()
          service.speak("تمت إضافة الذكر: " .. newDhikr)
          inputDialog.dismiss()
        else
          service.speak("الرجاء إدخال اسم الذكر")
        end
      end
    }
  }))
  inputDialog.show()
end

btnDeleteDhikr.onClick = function()
  local deletedDhikr = adhkar[currentIndex]
  local confirmDialog = LuaDialog(this)
  confirmDialog.setTitle("تأكيد الحذف")
  confirmDialog.setMessage("هل تريد حذف الذكر:\n«"..deletedDhikr.."»؟")
  confirmDialog.setPositiveButton("نعم", function()
    table.remove(adhkar, currentIndex)
    if currentIndex > #adhkar then currentIndex = #adhkar end
    currentDhikr = adhkar[currentIndex]
    updateUI()
    saveData()
    service.speak("تم حذف الذكر: " .. deletedDhikr)
  end)
  confirmDialog.setNegativeButton("لا", function()
    service.speak("تم الإلغاء")
  end)
  confirmDialog.show()
end

btnReset.onClick = function()
  local confirm = LuaDialog(this)
  confirm.setTitle("تأكيد البدء من جديد")
  confirm.setMessage("هل تريد البدء من جديد في ذكر:\n«"..adhkar[currentIndex].."»؟")
  confirm.setPositiveButton("نعم", function()
    counts[currentIndex] = 0
    updateUI()
    service.speak("صِفْرْ")
    saveData()
  end)
  confirm.setNegativeButton("لا", function()
    service.speak("تم الإلغاء")
  end)
  confirm.show()
end

btnClearAll.onClick = function()
  local confirm = LuaDialog(this)
  confirm.setTitle("تأكيد المسح")
  confirm.setMessage("هل تريد مسح عدادات جميع الأذكار؟")
  confirm.setPositiveButton("نعم", function()
    for i = 1, #counts do
      counts[i] = 0
    end
    updateUI()
    saveData()
    service.speak("تم مسح جميع العدادات")
  end)
  confirm.setNegativeButton("لا", function()
    service.speak("تم الإلغاء")
  end)
  confirm.show()
end

btnNext.onClick = function()
  currentIndex = currentIndex + 1
  if currentIndex > #adhkar then currentIndex = 1 end
  currentDhikr = adhkar[currentIndex]
  updateUI()
  service.speak(currentDhikr .. "، " .. tostring(math.floor(counts[currentIndex])))
  saveData()
end

btnPrev.onClick = function()
  currentIndex = currentIndex - 1
  if currentIndex < 1 then currentIndex = #adhkar end
  currentDhikr = adhkar[currentIndex]
  updateUI()
  service.speak(currentDhikr .. "، " .. tostring(math.floor(counts[currentIndex])))
  saveData()
end

btnPlus.onClick = function()
  counts[currentIndex] = counts[currentIndex] + 1
  updateUI()
  speakCount()
  saveData()
end

btnMinus.onClick = function()
  if counts[currentIndex] > 0 then
    counts[currentIndex] = counts[currentIndex] - 1
    updateUI()
    speakCount()
    saveData()
  end
end

btnToggleSayMode.onClick = function()
  sayMode = sayMode + 1
  if sayMode > 3 then sayMode = 1 end
  if sayMode == 1 then
    btnToggleSayMode.text = "نطق العدد فقط"
  elseif sayMode == 2 then
    btnToggleSayMode.text = "عدم النطق"
  elseif sayMode == 3 then
    btnToggleSayMode.text = "نطق الذكر والعدد"
  end
end

function speakCount()
  if sayMode == 1 then
    service.speak(currentDhikr .. "، " .. tostring(math.floor(counts[currentIndex])))
  elseif sayMode == 2 then
    service.speak(tostring(math.floor(counts[currentIndex])))
  end
end

dlg.setNegativeButton("خُرُوجْ", function() saveData() end)

updateUI()
dlg.show()